require 'lazy_map'

lazy_map = [1,2,3,4,5,6,7,8,9,10].lazy_map do |x|
  #something that takes a long time, so we only
  #want to do the minimum number of times
  puts "Processing #{x}"
  x * 10
end

puts lazy_map.detect {|x| x > 45}

#  Processing 1
#  Processing 2
#  Processing 3
#  Processing 4
#  Processing 5
#  50
