require 'size_limited_hash'

limited_hash = SizeLimitedHash.new(2)
limited_hash[:first] = 1
limited_hash[:second] = 2
limited_hash[:first] = 3

puts "Everything's ok so far: #{limited_hash.inspect}"
# Everything's ok so far: {:second=>2, :first=>3}

limited_hash[:third] = 4

puts "Where's :first => 3 gone?: #{limited_hash.inspect}"
# Where's :first => 3 gone?: {:second=>2, :third=>4}

